<?php

// ci.php
// Jeff Schwentner
// File provides page allowing user to input a description and post a file for CVS/RCS check-in...

define('CHORA_BASE', dirname(__FILE__));

if(isset($_POST['session_id'])) {
    session_name($_POST['session_name']);
    session_id($_POST['session_id']);
}

require_once CHORA_BASE . '/lib/base.php';
require_once CHORA_BASE . '/lib/ciLib.php';

// maintain $where value...   
// NOTE: Chora has builtin functionality to send and receive post data... 

$new_file = Util::getFormData('new_file', false);

if($new_file === false) {
    if(isset($_POST['new_file'])) {
        $new_file = $_POST['new_file'];
    } else {
        Chora::fatal("Checkin Failure: new_file operation not specified.");
    }
}

if(isset($_POST['filepath'])) $where = $_POST['filepath'];

$fullname = $sourceroot.'/'.$where;

$title = ($new_file) ? "File Checkin" : "Checkin for $where";

if($new_file) {
    $where .= '/';
    $where = str_replace('//', '/', $where);
}

if (!isset($_POST['uploaded_file'])) {
    $userWithLock = '';
    
    if(!$new_file && !file_locked($fullname, &$userWithLock)) {
        Chora::fatal("Checkin Failure: $where is not locked.");
    }
    
    if($new_file || Auth::getAuth() == $userWithLock) {
        // Repository File is locked, and ready for replacement...
        include CHORA_TEMPLATES . '/common-header.inc';
        Chora::menu();
        include CHORA_TEMPLATES . '/headerbar.inc';
        
        echo '<a name="diff"></a><br />
            <table  cellspacing="0" cellpadding="4">
            <tr class="diff-request"><td>
			<form enctype="multipart/form-data" action="ci.php" method="POST">';
        
		if($new_file) {
			echo 'Content: <input type="radio" name="binary" value = 0> ASCII
			      <input type="radio" name="binary" value = 1> Binary <br><br>
				  Enter a description for the initial version below:<br>';
        } else {
            echo 'Enter changes made since the previous version below:<br>';
        }
        
        echo '</td></tr>
            <tr class="diff-request"><td>
            
            <textarea NAME="ci_message" ROWS="10" COLS="80"></textarea><br>';

        // Preserve Session informaiton...
        if(session_id()) {
            echo '<input type="hidden" name="session_name" value="'.session_name().'">
                  <input type="hidden" name="session_id" value="'.session_id().'">';
        }

        // Preserve New Checkin Information
        if($new_file) {
            echo '<input type="hidden" name="new_file" value="'.$new_file.'">';
        }

        echo '<input type="hidden" name="uploaded_file" value=1>
            <input type="hidden" name="new_file" value="'.$new_file.'">
			<input type="hidden" name="filepath" value="'.$where.'"> 
            <input type="hidden" name="MAX_FILE_SIZE" value="500000"> Location: <input name="userfile" style = "width: 79%" type="file">
            <input type="submit" value="Send File">
            </form></td></tr>
            </table>';
    } else {
        Chora::fatal("Checkin Failure: $where is locked by $userWithLock.");
    }

} else { // File has been uploaded... check for errors...
    $temp_pos = false;

    // Check for a valid message...
    $_POST['ci_message'] = trim($_POST['ci_message']);
    
    if($_POST['ci_message'] == '') {
        if(!$new_file) unlock_file($fullname);
        Chora::fatal("Checkin Failure: No change log or initial description specified.");
    }

    // Check for upload errors...
    if($_FILES['userfile']['error'] != 0) {
        if(!$new_file) unlock_file($fullname);
        Chora::fatal("Checkin Failure: Uploaded file ".
            $_FILES['userfile']['error']." caused an error (code: ".$_FILES['userfile']['error'].").");
    }
    
    // Check for a valid filesize...
    if($_FILES['userfile']['size'] <= 0) {
        if(!$new_file) unlock_file($fullname);
        Chora::fatal("Checkin Failure: '".$_FILES['userfile']['name']."' is not a valid file.");
    }

    // Check for the filename...
    if(!$new_file) {
        $base_file = basename($where);
        $temp_pos = strpos($_FILES['userfile']['name'], $base_file);
    
        if($temp_pos === false || $temp_pos != (strlen($_FILES['userfile']['name']) - strlen($base_file))) {
            unlock_file($fullname);
            Chora::fatal("Checkin Failure: Uploaded file '".$_FILES['userfile']['name']."' does not match $where.");
        }
        $dest_file = $sourceroot.'/'.$where;
    
    } else {
        $dest_file = $sourceroot.'/'.$where.$_FILES['userfile']['name'];
        $dest_file = preg_replace('/(\\/)(\\/)/', '/', $dest_file);
        
        // Check to see if file already exists...
        if(file_exists($dest_file.',v')) {
            Chora::fatal("Checkin Failure: ".$_FILES['userfile']['name']." already exists at the current location.");
        }
    }

    // Move the tmp file to the appropriate directory (and check validity)...
    if(!move_uploaded_file($_FILES['userfile']['tmp_name'], $dest_file)) {
        if(!$new_file) unlock_file($fullname);
        Chora::fatal("Checkin Failure: Uploaded file ".$_FILES['userfile']['name']." could not be validated (or moved).");
    }

    if(!$new_file){
		check_in($dest_file, $_POST['ci_message']);	
		unlock_file($fullname);
	} 
	else if(isset($_POST['binary']) && $_POST['binary']){
		check_in($dest_file, $_POST['ci_message'], true);	
	}
	else {
		check_in($dest_file, $_POST['ci_message']);	
	}

    header("Location: ".Horde::url(Chora::url('cvs', $where), true)); 
}

?>
